{
  This file was automatically generated on 2018-11-28.

  Delphi/Lazarus Bindings Version 2.1.22

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletIsolator;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ISOLATOR_DEVICE_IDENTIFIER = 2122;
  BRICKLET_ISOLATOR_DEVICE_DISPLAY_NAME = 'Isolator Bricklet';

  BRICKLET_ISOLATOR_FUNCTION_GET_STATISTICS = 1;
  BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE_CONFIG = 2;
  BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE_CONFIG = 3;
  BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE = 4;
  BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE = 5;
  BRICKLET_ISOLATOR_FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT = 6;
  BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_ISOLATOR_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_ISOLATOR_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_ISOLATOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_ISOLATOR_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_ISOLATOR_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_ISOLATOR_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_ISOLATOR_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_ISOLATOR_FUNCTION_RESET = 243;
  BRICKLET_ISOLATOR_FUNCTION_WRITE_UID = 248;
  BRICKLET_ISOLATOR_FUNCTION_READ_UID = 249;
  BRICKLET_ISOLATOR_FUNCTION_GET_IDENTITY = 255;


  BRICKLET_ISOLATOR_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_ISOLATOR_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_ISOLATOR_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_ISOLATOR_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_ISOLATOR_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_ISOLATOR_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_ISOLATOR_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_ISOLATOR_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_ISOLATOR_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ISOLATOR_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  /// <summary>
  ///  Galvanically isolates any Bricklet from any Brick
  /// </summary>
  TBrickletIsolator = class(TDevice)
  private
  protected
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns statistics for the Isolator Bricklet.
    /// </summary>
    procedure GetStatistics(out messagesFromBrick: longword; out messagesFromBricklet: longword; out connectedBrickletDeviceIdentifier: word; out connectedBrickletUID: string); virtual;

    /// <summary>
    ///  The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is
    ///  enabled, the Isolator Bricklet will try to adapt the baudrate for the communication
    ///  between Bricks and Bricklets according to the amount of data that is transferred.
    ///  
    ///  The baudrate for communication config between
    ///  Brick and Isolator Bricklet can be set through the API of the Brick.
    ///  
    ///  The baudrate will be increased exponentially if lots of data is send/received and
    ///  decreased linearly if little data is send/received.
    ///  
    ///  This lowers the baudrate in applications where little data is transferred (e.g.
    ///  a weather station) and increases the robustness. If there is lots of data to transfer
    ///  (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.
    ///  
    ///  In cases where some data has to transferred as fast as possible every few seconds
    ///  (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn
    ///  the dynamic baudrate off to get the highest possible performance.
    ///  
    ///  The maximum value of the baudrate can be set per port with the function
    ///  <see cref="BrickletIsolator.TBrickletIsolator.SetSPITFPBaudrate"/>. If the dynamic baudrate is disabled, the baudrate
    ///  as set by <see cref="BrickletIsolator.TBrickletIsolator.SetSPITFPBaudrate"/> will be used statically.
    ///  
    ///  The minimum dynamic baudrate has a value range of 400000 to 2000000 baud.
    ///  
    ///  By default dynamic baudrate is enabled and the minimum dynamic baudrate is 400000.
    /// </summary>
    procedure SetSPITFPBaudrateConfig(const enableDynamicBaudrate: boolean; const minimumDynamicBaudrate: longword); virtual;

    /// <summary>
    ///  Returns the baudrate config, see <see cref="BrickletIsolator.TBrickletIsolator.SetSPITFPBaudrateConfig"/>.
    /// </summary>
    procedure GetSPITFPBaudrateConfig(out enableDynamicBaudrate: boolean; out minimumDynamicBaudrate: longword); virtual;

    /// <summary>
    ///  Sets the baudrate for a the communication between Isolator Bricklet
    ///  and the connected Bricklet. The baudrate for communication between
    ///  Brick and Isolator Bricklet can be set through the API of the Brick.
    ///  
    ///  The baudrate can be in the range 400000 to 2000000.
    ///  
    ///  If you want to increase the throughput of Bricklets you can increase
    ///  the baudrate. If you get a high error count because of high
    ///  interference (see <see cref="BrickletIsolator.TBrickletIsolator.GetSPITFPErrorCount"/>) you can decrease the
    ///  baudrate.
    ///  
    ///  If the dynamic baudrate feature is enabled, the baudrate set by this
    ///  function corresponds to the maximum baudrate (see <see cref="BrickletIsolator.TBrickletIsolator.SetSPITFPBaudrateConfig"/>).
    ///  
    ///  Regulatory testing is done with the default baudrate. If CE compatibility
    ///  or similar is necessary in you applications we recommend to not change
    ///  the baudrate.
    ///  
    ///  The default baudrate for all ports is 1400000.
    /// </summary>
    procedure SetSPITFPBaudrate(const baudrate: longword); virtual;

    /// <summary>
    ///  Returns the baudrate, see <see cref="BrickletIsolator.TBrickletIsolator.SetSPITFPBaudrate"/>.
    /// </summary>
    function GetSPITFPBaudrate: longword; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Isolator Bricklet and
    ///  the connected Bricklet. Call <see cref="BrickletIsolator.TBrickletIsolator.GetSPITFPErrorCount"/> to get the
    ///  error count between Isolator Bricklet and Brick.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    /// </summary>
    procedure GetIsolatorSPITFPErrorCount(out errorCountACKChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletIsolator.TBrickletIsolator.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletIsolator.TBrickletIsolator.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletIsolator.TBrickletIsolator.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletIsolator.TBrickletIsolator.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature in °C as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;
  end;

implementation

constructor TBrickletIsolator.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_STATISTICS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ISOLATOR_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

end;

procedure TBrickletIsolator.GetStatistics(out messagesFromBrick: longword; out messagesFromBricklet: longword; out connectedBrickletDeviceIdentifier: word; out connectedBrickletUID: string);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_STATISTICS, 8);
  response := SendRequest(request);
  messagesFromBrick := LEConvertUInt32From(8, response);
  messagesFromBricklet := LEConvertUInt32From(12, response);
  connectedBrickletDeviceIdentifier := LEConvertUInt16From(16, response);
  connectedBrickletUID := LEConvertStringFrom(18, 8, response);
end;

procedure TBrickletIsolator.SetSPITFPBaudrateConfig(const enableDynamicBaudrate: boolean; const minimumDynamicBaudrate: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE_CONFIG, 13);
  LEConvertBooleanTo(enableDynamicBaudrate, 8, request);
  LEConvertUInt32To(minimumDynamicBaudrate, 9, request);
  SendRequest(request);
end;

procedure TBrickletIsolator.GetSPITFPBaudrateConfig(out enableDynamicBaudrate: boolean; out minimumDynamicBaudrate: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE_CONFIG, 8);
  response := SendRequest(request);
  enableDynamicBaudrate := LEConvertBooleanFrom(8, response);
  minimumDynamicBaudrate := LEConvertUInt32From(9, response);
end;

procedure TBrickletIsolator.SetSPITFPBaudrate(const baudrate: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_SET_SPITFP_BAUDRATE, 12);
  LEConvertUInt32To(baudrate, 8, request);
  SendRequest(request);
end;

function TBrickletIsolator.GetSPITFPBaudrate: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_BAUDRATE, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletIsolator.GetIsolatorSPITFPErrorCount(out errorCountACKChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_ISOLATOR_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountACKChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

procedure TBrickletIsolator.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletIsolator.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletIsolator.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletIsolator.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request);
end;

function TBrickletIsolator.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletIsolator.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletIsolator.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletIsolator.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletIsolator.Reset;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_RESET, 8);
  SendRequest(request);
end;

procedure TBrickletIsolator.WriteUID(const uid: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request);
end;

function TBrickletIsolator.ReadUID: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_READ_UID, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletIsolator.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ISOLATOR_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

end.
