{
  This file was automatically generated on 2018-11-28.

  Delphi/Lazarus Bindings Version 2.1.22

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletOLED128x64V2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_OLED_128X64_V2_DEVICE_IDENTIFIER = 2112;
  BRICKLET_OLED_128X64_V2_DEVICE_DISPLAY_NAME = 'OLED 128x64 Bricklet 2.0';

  BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_PIXELS_LOW_LEVEL = 1;
  BRICKLET_OLED_128X64_V2_FUNCTION_READ_PIXELS_LOW_LEVEL = 2;
  BRICKLET_OLED_128X64_V2_FUNCTION_CLEAR_DISPLAY = 3;
  BRICKLET_OLED_128X64_V2_FUNCTION_SET_DISPLAY_CONFIGURATION = 4;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_DISPLAY_CONFIGURATION = 5;
  BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_LINE = 6;
  BRICKLET_OLED_128X64_V2_FUNCTION_DRAW_BUFFERED_FRAME = 7;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_OLED_128X64_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_OLED_128X64_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_OLED_128X64_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_OLED_128X64_V2_FUNCTION_RESET = 243;
  BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_OLED_128X64_V2_FUNCTION_READ_UID = 249;
  BRICKLET_OLED_128X64_V2_FUNCTION_GET_IDENTITY = 255;


  BRICKLET_OLED_128X64_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_OLED_128X64_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_OLED_128X64_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_OLED_128X64_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_OLED_128X64_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_OLED_128X64_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To447OfBoolean = array [0..447] of boolean;
  TArray0To479OfBoolean = array [0..479] of boolean;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArrayOfBoolean = array of boolean;

  /// <summary>
  ///  3.3cm (1.3") OLED display with 128x64 pixels
  /// </summary>
  TBrickletOLED128x64V2 = class(TDevice)
  private
    streamMutex: TCriticalSection;
  protected
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid__: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Writes pixels to the specified window.
    ///  
    ///  The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are written
    ///  into the window line by line top to bottom and each line is written from left to
    ///  right.
    ///  
    ///  If automatic draw is enabled (default) the pixels are directly written to
    ///  the screen. Only pixels that have actually changed are updated on the screen,
    ///  the rest stays the same.
    ///  
    ///  If automatic draw is disabled the pixels are written to an internal buffer and
    ///  the buffer is transferred to the display only after <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.DrawBufferedFrame"/>
    ///  is called. This can be used to avoid flicker when drawing a complex frame in
    ///  multiple steps.
    ///  
    ///  Automatic draw can be configured with the <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>
    ///  function.
    /// </summary>
    procedure WritePixelsLowLevel(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; const pixelsLength: word; const pixelsChunkOffset: word; const pixelsChunkData: TArray0To447OfBoolean); virtual;

    /// <summary>
    ///  Writes pixels to the specified window.
    ///  
    ///  The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are written
    ///  into the window line by line top to bottom and each line is written from left to
    ///  right.
    ///  
    ///  If automatic draw is enabled (default) the pixels are directly written to
    ///  the screen. Only pixels that have actually changed are updated on the screen,
    ///  the rest stays the same.
    ///  
    ///  If automatic draw is disabled the pixels are written to an internal buffer and
    ///  the buffer is transferred to the display only after <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.DrawBufferedFrame"/>
    ///  is called. This can be used to avoid flicker when drawing a complex frame in
    ///  multiple steps.
    ///  
    ///  Automatic draw can be configured with the <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>
    ///  function.
    /// </summary>
    procedure WritePixels(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; const pixels: array of boolean); virtual;

    /// <summary>
    ///  Reads pixels from the specified window.
    ///  
    ///  The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are read
    ///  from the window line by line top to bottom and each line is read from left to
    ///  right.
    ///  
    ///  If automatic draw is enabled (default) the pixels that are read are always the
    ///  same that are shown on the display.
    ///  
    ///  If automatic draw is disabled the pixels are read from the internal buffer
    ///  (see <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.DrawBufferedFrame"/>).
    ///  
    ///  Automatic draw can be configured with the <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>
    ///  function.
    /// </summary>
    procedure ReadPixelsLowLevel(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; out pixelsLength: word; out pixelsChunkOffset: word; out pixelsChunkData: TArray0To479OfBoolean); virtual;

    /// <summary>
    ///  Reads pixels from the specified window.
    ///  
    ///  The x-axis goes from 0 to 127 and the y-axis from 0 to 63. The pixels are read
    ///  from the window line by line top to bottom and each line is read from left to
    ///  right.
    ///  
    ///  If automatic draw is enabled (default) the pixels that are read are always the
    ///  same that are shown on the display.
    ///  
    ///  If automatic draw is disabled the pixels are read from the internal buffer
    ///  (see <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.DrawBufferedFrame"/>).
    ///  
    ///  Automatic draw can be configured with the <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>
    ///  function.
    /// </summary>
    function ReadPixels(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte): TArrayOfBoolean; virtual;

    /// <summary>
    ///  Clears the complete content of the display.
    /// </summary>
    procedure ClearDisplay; virtual;

    /// <summary>
    ///  Sets the configuration of the display.
    ///  
    ///  You can set a contrast value from 0 to 255 and you can invert the color
    ///  (white/black) of the display.
    ///  
    ///  If automatic draw is set to *true*, the display is automatically updated with every
    ///  call of <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.WritePixels"/> or <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.WriteLine"/>. If it is set to false, the
    ///  changes are written into an internal buffer and only shown on the display after
    ///  a call of <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.DrawBufferedFrame"/>.
    ///  
    ///  The default values are contrast 143, inverting off and automatic draw on.
    /// </summary>
    procedure SetDisplayConfiguration(const contrast: byte; const invert: boolean; const automaticDraw: boolean); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>.
    /// </summary>
    procedure GetDisplayConfiguration(out contrast: byte; out invert: boolean; out automaticDraw: boolean); virtual;

    /// <summary>
    ///  Writes text to a specific line (0 to 7) with a specific position
    ///  (0 to 21). The text can have a maximum of 22 characters.
    ///  
    ///  For example: (1, 10, "Hello") will write *Hello* in the middle of the
    ///  second line of the display.
    ///  
    ///  The display uses a special 5x7 pixel charset. You can view the characters
    ///  of the charset in Brick Viewer.
    /// </summary>
    procedure WriteLine(const line: byte; const position: byte; const text: string); virtual;

    /// <summary>
    ///  Draws the currently buffered frame. Normally each call of <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.WritePixels"/> and
    ///  <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.WriteLine"/> draws directly onto the display. If you turn automatic draw off
    ///  (<see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetDisplayConfiguration"/>), the data is written in an internal buffer and
    ///  only transferred to the display by calling this function. This can be used to
    ///  avoid flicker when drawing a complex frame in multiple steps.
    ///  
    ///  Set the `force complete redraw` to *true* to redraw the whole display
    ///  instead of only the changed parts. Normally it should not be necessary to set this to
    ///  *true*. It may only become necessary in case of stuck pixels because of errors.
    /// </summary>
    procedure DrawBufferedFrame(const forceCompleteRedraw: boolean); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletOLED128x64V2.TBrickletOLED128x64V2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature in °C as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c' or 'd'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;
  end;

implementation

constructor TBrickletOLED128x64V2.Create(const uid__: string; ipcon_: TIPConnection);
begin
  inherited Create(uid__, ipcon_);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_PIXELS_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_READ_PIXELS_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_CLEAR_DISPLAY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_SET_DISPLAY_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_DISPLAY_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_LINE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_DRAW_BUFFERED_FRAME] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_OLED_128X64_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;

end;

procedure TBrickletOLED128x64V2.WritePixelsLowLevel(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; const pixelsLength: word; const pixelsChunkOffset: word; const pixelsChunkData: TArray0To447OfBoolean);
var request: TByteArray; i: longint; pixelsChunkDataBits: array [0..55] of byte;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_PIXELS_LOW_LEVEL, 72);
  LEConvertUInt8To(xStart, 8, request);
  LEConvertUInt8To(yStart, 9, request);
  LEConvertUInt8To(xEnd, 10, request);
  LEConvertUInt8To(yEnd, 11, request);
  LEConvertUInt16To(pixelsLength, 12, request);
  LEConvertUInt16To(pixelsChunkOffset, 14, request);
  FillChar(pixelsChunkDataBits[0], Length(pixelsChunkDataBits) * SizeOf(pixelsChunkDataBits[0]), 0);
  for i := 0 to 447 do if pixelsChunkData[i] then pixelsChunkDataBits[Floor(i/8)] := pixelsChunkDataBits[Floor(i/8)] or (1 shl (i mod 8));
  for i := 0 to 55 do LEConvertUInt8To(pixelsChunkDataBits[i], 16 + (i * 1), request);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.WritePixels(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; const pixels: array of boolean);
var
  pixelsChunkOffset: word;
  pixelsChunkData: TArray0To447OfBoolean;
  pixelsChunkLength: word;
  pixelsLength: word;
begin
  if (Length(pixels) > 65535) then begin
    raise EInvalidParameterException.Create('Pixels can be at most 65535 items long');
  end;

  pixelsLength := Length(pixels);
  pixelsChunkOffset := 0;

  if (pixelsLength = 0) then begin
    FillChar(pixelsChunkData[0], SizeOf(boolean) * 448, 0);
    WritePixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
  end
  else begin
    streamMutex.Acquire;
    try
      while (pixelsChunkOffset < pixelsLength) do begin
        pixelsChunkLength := pixelsLength - pixelsChunkOffset;

        if (pixelsChunkLength > 448) then pixelsChunkLength := 448;

        FillChar(pixelsChunkData[0], SizeOf(boolean) * 448, 0);
        Move(pixels[pixelsChunkOffset], pixelsChunkData[0], SizeOf(boolean) * pixelsChunkLength);

        WritePixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
        Inc(pixelsChunkOffset, 448);
      end;
    finally
      streamMutex.Release;
    end;
  end;
end;

procedure TBrickletOLED128x64V2.ReadPixelsLowLevel(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte; out pixelsLength: word; out pixelsChunkOffset: word; out pixelsChunkData: TArray0To479OfBoolean);
var request, response: TByteArray; i: longint; pixelsChunkDataBits: array [0..59] of byte;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_READ_PIXELS_LOW_LEVEL, 12);
  LEConvertUInt8To(xStart, 8, request);
  LEConvertUInt8To(yStart, 9, request);
  LEConvertUInt8To(xEnd, 10, request);
  LEConvertUInt8To(yEnd, 11, request);
  response := SendRequest(request);
  pixelsLength := LEConvertUInt16From(8, response);
  pixelsChunkOffset := LEConvertUInt16From(10, response);
  FillChar(pixelsChunkDataBits[0], Length(pixelsChunkDataBits) * SizeOf(pixelsChunkDataBits[0]), 0);
  for i := 0 to 59 do pixelsChunkDataBits[i] := LEConvertUInt8From(12 + (i * 1), response);
  for i := 0 to 479 do pixelsChunkData[i] := ((pixelsChunkDataBits[Floor(i / 8)] and (1 shl (i mod 8))) <> 0);
end;

function TBrickletOLED128x64V2.ReadPixels(const xStart: byte; const yStart: byte; const xEnd: byte; const yEnd: byte): TArrayOfBoolean;
var
  pixels: TArrayOfBoolean;
  pixelsCurrentLength: word;
  pixelsLength: word;
  pixelsChunkOffset: word;
  pixelsChunkData: TArray0To479OfBoolean;
  pixelsOutOfSync: boolean;
  pixelsChunkLength: word;
begin
  SetLength(result, 0);
  SetLength(pixels, 0);
  streamMutex.Acquire;
  try
    pixelsLength := 0;
    ReadPixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
    SetLength(pixels, pixelsLength);
    pixelsOutOfSync := (pixelsChunkOffset <> 0);

    if ((not pixelsOutOfSync) and (pixelsLength > 0)) then begin
      pixelsChunkLength := pixelsLength - pixelsChunkOffset;
      if (pixelsChunkLength > 480) then pixelsChunkLength := 480;
      Move(pixelsChunkData, pixels[0], SizeOf(boolean) * pixelsChunkLength);
      pixelsCurrentLength := pixelsChunkLength;

      while ((not pixelsOutOfSync) and (pixelsCurrentLength < pixelsLength)) do begin
        ReadPixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
        pixelsOutOfSync := pixelsChunkOffset <> pixelsCurrentLength;
        pixelsChunkLength := pixelsLength - pixelsChunkOffset;
        if (pixelsChunkLength > 480) then pixelsChunkLength := 480;
        Move(pixelsChunkData, pixels[pixelsCurrentLength], SizeOf(boolean) * pixelsChunkLength);
        Inc(pixelsCurrentLength, pixelsChunkLength);
      end;
    end;

    if (pixelsOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (pixelsChunkOffset + 480 < pixelsLength) do begin
        ReadPixelsLowLevel(xStart, yStart, xEnd, yEnd, pixelsLength, pixelsChunkOffset, pixelsChunkData);
      end;

      raise EStreamOutOfSyncException.Create('Pixels stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
  result := pixels;
end;

procedure TBrickletOLED128x64V2.ClearDisplay;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_CLEAR_DISPLAY, 8);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.SetDisplayConfiguration(const contrast: byte; const invert: boolean; const automaticDraw: boolean);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_SET_DISPLAY_CONFIGURATION, 11);
  LEConvertUInt8To(contrast, 8, request);
  LEConvertBooleanTo(invert, 9, request);
  LEConvertBooleanTo(automaticDraw, 10, request);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.GetDisplayConfiguration(out contrast: byte; out invert: boolean; out automaticDraw: boolean);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_DISPLAY_CONFIGURATION, 8);
  response := SendRequest(request);
  contrast := LEConvertUInt8From(8, response);
  invert := LEConvertBooleanFrom(9, response);
  automaticDraw := LEConvertBooleanFrom(10, response);
end;

procedure TBrickletOLED128x64V2.WriteLine(const line: byte; const position: byte; const text: string);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_LINE, 32);
  LEConvertUInt8To(line, 8, request);
  LEConvertUInt8To(position, 9, request);
  LEConvertStringTo(text, 10, 22, request);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.DrawBufferedFrame(const forceCompleteRedraw: boolean);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_DRAW_BUFFERED_FRAME, 9);
  LEConvertBooleanTo(forceCompleteRedraw, 8, request);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletOLED128x64V2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOLED128x64V2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOLED128x64V2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request);
end;

function TBrickletOLED128x64V2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletOLED128x64V2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request);
end;

function TBrickletOLED128x64V2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletOLED128x64V2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletOLED128x64V2.Reset;
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_RESET, 8);
  SendRequest(request);
end;

procedure TBrickletOLED128x64V2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request);
end;

function TBrickletOLED128x64V2.ReadUID: longword;
var request, response: TByteArray;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletOLED128x64V2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_OLED_128X64_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

end.
